Subject: 24.0.50; `display-buffer' does not respect `pop-up-frames'
From: "Drew Adams" <[email-masked]>
To: <[email-masked]>
Date: Tue, 14 Jun 2011 11:14:07 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

My setup, not emacs -Q.

Summary: A non-interactive call to `display-buffer' with non-nil arg
NOT-THIS-WINDOW does not show the buffer in a separate frame, even though
`pop-up-frames' is non-nil.
 
I have non-nil `pop-up-frames'.  I use the following function via `M-x
find-library-other-window frame.el'.  It should find the library in a
separate frame.  Instead, it finds it in another window of the current
frame - i.e., it splits the current window and puts it in one of those
two windows.
 
(defun find-library-other-window (library)
  "Find the Emacs-Lisp source of LIBRARY in another window."
  (interactive
   (let* ((path (cons (or find-function-source-path load-path)
        (find-library-suffixes)))
   (def (if (eq (function-called-at-point) 'require)
     (save-excursion (backward-up-list)
                                   (forward-char)
                                   (backward-sexp -2)
                                   (thing-at-point 'symbol))
   (thing-at-point 'symbol))))
     (when def (setq def (and (locate-file-completion def path 'test) def)))
     (list (completing-read "Library name: " 'locate-file-completion
                            path nil nil nil def))))
  (let ((buf (find-file-noselect (find-library-name library))))
    (pop-to-buffer buf 'other-window)))
 
Invoking `M-x find-library-other-window frame.el' leads to the following
call chain (from the debugger):
 
(display-buffer #<buffer frame.el> other-window nil)
 
(display-buffer-normalize-specifiers "frame.el" other-window nil)
returns the following sexp, which I'll call FOO below:
 
((reuse-window other same visible)
 (pop-up-window (largest) (lru))
 (pop-up-frame)
 (reuse-window other other visible)
 (reuse-window nil same 0)
 (reuse-window-even-sizes . t)
 (pop-up-frame t)
 (pop-up-frame-function lambda nil (make-frame pop-up-frame-alist))
 (reuse-window nil same visible)
 (pop-up-window (largest) (lru))
 (pop-up-frame)
 (reuse-window nil other visible)
 (reuse-window-even-sizes . t)
 (reuse-window nil same visible)
 (pop-up-window (largest) (lru))
 (pop-up-frame)
 (pop-up-frame-alist (height . 24) (width . 80) (unsplittable . t))
 (reuse-window nil other visible)
 (reuse-window-even-sizes . t))
 
Then, * display-buffer-reuse-window(
#<buffer frame.el> 
(other same visible)
FOO)
 
returns: nil
 
Then, * display-buffer-pop-up-window(
#<buffer frame.el>
((largest) (lru))
FOO)
 
calls * display-buffer-split-window(
#<window 8 on drews-lisp-20> 
nil
FOO)
 
which calls * display-buffer-split-window-1(
#<window 8 on drews-lisp-20> below 4)
 
which calls * split-window(
#<window 8 on drews-lisp-20> nil below)
 
which calls * resize-this-window(
#<window 8 on drews-lisp-20> -29 nil)
 
which calls * split-window-internal(
#<window 8 on drews-lisp-20> 29 below 0.5)
 
which splits the window and then throws, putting the frame.el buffer in
the second window (instead of its own frame).

 

In GNU Emacs 24.0.50.1 (i386-mingw-nt5.1.2600)
 of 2011-06-13 on 3249CTO
Windowing system distributor `Microsoft Corp.', version 5.1.2600
configured using `configure --with-gcc (4.5) --no-opt --cflags
-Ic:/build/include'